-- List of flagged voice line IDs.
local r = {
	"play_pln_gen_count_17",
	"Play_pln_branchbank_stage1_83",
	"play_pln_gen_urg_01",
	"play_pln_gen_dir_07",
	"play_pln_gen_dir_08",
	"diegetic_club_music",
	"diegetic_club_rock_music",
	"diegetic_lounge_music",
	"cloaker_detect_mono",
	"cloaker_presence_loop",
	"cpa_a03_01",
	"cpa_a02_01",
	"cpw_a04",
	"cpw_a05",
	"cpa_a04_01",
	"bdz_entrance",
	"bdz_entrance_elite",
	"cloaker_detect_christmas_mono",
	"cloaker_taunt_after_assault",
	"alarmbomb",
	"camera_alarm_signal",
	"alarm_countdown_loop",
	"alarm_countdown_ticking_down_10sec",
	"alarm_fire",
	"alarm_kosugi_on_slow_fade",
	"alarm_museum_on_slow_fade",
	"alarm_the_bomb_on_slow_fade",
	"hitec_lotec_alarm_slow_fade",
	"jewelry_alarm_on_slow_fade",
	"swatturret_alert",
	"swat_explosion",
	"swat_blows_window_medium",
	"shield_identification",
	"c4_beep_loop",
	"cm1_burndeath",
	"tsr_burndeath",
	"tsr_x02a_any_3p",
	"clk_burndeath",
	"clk_x02a_any_3p",
	"bdz_x02a_any_3p",
	"bdz_visor_lost",
	"santa_hoho",
	"criminals_ambition",
	"criminals_ambition_instrumental",
	"pth_criminal_intent",
	"goat_fan_woosh",
	"goat_hang_scaffold",
	"goat_headbutt",
	"goat_kick",
	"goat_lick",
	"goat_says_meh",
	"goat_says_meh_loop",
	"goat_sleep",
	"v34",
	"v55",
	"g29",
	"g60",
	"whistling_attention"
}

local f = f or {}

local MuteFlaggedSound = false -- If enabled, any flagged sound will be muted when played.
local FlagCountsToMute = 5 -- Determines how many flags it will take to completely mute a player.

local function IsFlagged( i )

	for _ , c in ipairs( r ) do
		if SoundDevice:string_to_id( c ) == i then
			return c
		end
	end

end

Hooks:PreHook( UnitNetworkHandler , "bain_comment" , "AntiVoiceSpamPreUnitNetworkHandlerBainComment" , function( self , bain_line , sender )

	if not self._verify_sender( sender ) then
		return
	end
	
	local peer = self._verify_sender( sender )
	
	if IsFlagged( bain_line ) then
		managers.chat:feed_system_message( ChatManager.GAME , peer:name() .. " used a flagged id: \"" .. IsFlagged( bain_line ) .. "\"." )
		
		f[ peer:id() ] = f[ peer:id() ] or {}
		f[ peer:id() ].c = f[ peer:id() ].c and f[ peer:id() ].c + 1 or 1
		
		if MuteFlaggedSound then bain_line = "Stop_all_music" end
	end
	
	if f[ peer:id() ] and f[ peer:id() ].c >= FlagCountsToMute then
		bain_line = "Stop_all_music"
	end

end )

Hooks:PostHook( UnitNetworkHandler , "say" , "AntiVoiceSpamPostUnitNetworkHandlerSay" , function( self , unit , event_id , sender )

	if not alive( unit ) or not self._verify_gamestate( self._gamestate_filter.any_ingame ) or not self._verify_sender( sender ) then
		return
	end
	
	local peer = self._verify_sender( sender )
	
	if peer:unit() and peer:unit():key() == unit:key() then
		if IsFlagged( event_id ) then
			managers.chat:feed_system_message( ChatManager.GAME , peer:name() .. " used a flagged id: \"" .. IsFlagged( event_id ) .. "\"." )
			
			f[ peer:id() ] = f[ peer:id() ] or {}
			f[ peer:id() ].c = f[ peer:id() ].c and f[ peer:id() ].c + 1 or 1
			
			if MuteFlaggedSound then
				unit:sound():stop()
				if unit:sound()._last_speech then
					unit:sound()._last_speech:stop()
				end
				unit:sound():say( "Stop_all_music" , false , false )
			end
		end
		
		if f[ peer:id() ] and f[ peer:id() ].c >= FlagCountsToMute then
			unit:sound():stop()
			if unit:sound()._last_speech then
				unit:sound()._last_speech:stop()
			end
			unit:sound():say( "Stop_all_music" , false , false )
		end
	end

end )

Hooks:PostHook( UnitNetworkHandler , "unit_sound_play" , "AntiVoiceSpamPostUnitNetworkHandlerUnitSoundPlay" , function( self , unit , event_id , source , sender )

	if not alive( unit ) or not self._verify_sender( sender ) then
		return
	end
	
	local peer = self._verify_sender( sender )
	
	if source == "" then
		source = nil
	end
	
	if peer:unit() and peer:unit():key() == unit:key() then
		if IsFlagged( event_id ) then
			managers.chat:feed_system_message( ChatManager.GAME , peer:name() .. " used a flagged id: \"" .. IsFlagged( event_id ) .. "\"." )
			
			f[ peer:id() ] = f[ peer:id() ] or {}
			f[ peer:id() ].c = f[ peer:id() ].c and f[ peer:id() ].c + 1 or 1
			
			if MuteFlaggedSound then
				unit:sound():stop( source )
				if unit:sound()._last_speech then
					unit:sound()._last_speech:stop( source )
				end
				unit:sound():_play( "Stop_all_music" , source )
			end
		end
		
		if f[ peer:id() ] and f[ peer:id() ].c >= FlagCountsToMute then
			unit:sound():stop( source )
			if unit:sound()._last_speech then
				unit:sound()._last_speech:stop( source )
			end
			unit:sound():_play( "Stop_all_music" , source )
		end
	end

end )